'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = combineConstraints;

var _executeMessage = require('./executeMessage');

var _executeMessage2 = _interopRequireDefault(_executeMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function combineConstraints(constraints) {
  var message = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

  var keys = Object.keys(constraints);

  return function (value, context) {
    return Promise.all(keys.map(function (key) {
      return constraints[key](value, context);
    })).then(function (values) {
      var children = keys.reduce(function (acc, key, index) {
        return acc[key] = values[index], acc;
      }, {});

      var valid = keys.every(function (key) {
        return children[key].valid;
      });

      return {
        valid: valid,
        message: valid ? null : (0, _executeMessage2.default)(value, context, children, message || 'Value is not valid'),
        children: children
      };
    });
  };
}