'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createConstraint;

var _executeMessage = require('./executeMessage');

var _executeMessage2 = _interopRequireDefault(_executeMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createConstraint(validator) {
  var message = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

  return function (value, context) {
    return Promise.resolve(validator(value)).then(function (valid) {
      return {
        valid: valid,
        message: valid ? null : (0, _executeMessage2.default)(value, context, null, message || 'Value is not valid'),
        children: null
      };
    });
  };
}