'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = createObjectConstraint;

var _executeMessage = require('./executeMessage');

var _executeMessage2 = _interopRequireDefault(_executeMessage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createObjectConstraint(constraints) {
  var message = arguments.length <= 1 || arguments[1] === undefined ? null : arguments[1];

  var keys = Object.keys(constraints);

  return function (value, context) {
    if (!value || (typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== 'object') {
      return Promise.resolve({
        valid: false,
        message: (0, _executeMessage2.default)(value, context, [], message || 'Object is not valid'),
        children: {}
      });
    }

    return Promise.all(keys.map(function (key) {
      return constraints[key](value[key], context);
    })).then(function (values) {
      var children = keys.reduce(function (acc, key, index) {
        return acc[key] = values[index], acc;
      }, {});

      var valid = keys.every(function (key) {
        return children[key].valid;
      });

      return {
        valid: valid,
        message: valid ? null : (0, _executeMessage2.default)(value, context, children, message || 'Object is not valid'),
        children: children
      };
    });
  };
}