'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = nullableConstraint;

var _validators = require('../validators');

function nullableConstraint(constraint) {
  return function (value, context) {
    return constraint(value, context).then(function (children) {
      var valueIsNull = (0, _validators.isNull)(value);

      return {
        valid: valueIsNull ? true : children.valid,
        message: valueIsNull ? null : children.message,
        children: children.children
      };
    });
  };
}