'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isNotNull = isNotNull;
exports.isNull = isNull;
exports.isBoolean = isBoolean;
exports.isTrue = isTrue;
exports.isFalse = isFalse;
exports.isNumber = isNumber;
exports.isNotANumber = isNotANumber;
exports.isInfinity = isInfinity;
exports.isString = isString;
exports.isObject = isObject;
exports.isPlainObject = isPlainObject;
exports.isArray = isArray;
exports.isRegExp = isRegExp;
exports.isDate = isDate;
exports.isFunction = isFunction;
exports.isEmail = isEmail;
exports.isUppercase = isUppercase;
exports.isLowercase = isLowercase;
exports.isNotEmpty = isNotEmpty;
exports.isEmpty = isEmpty;

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _isBoolean2 = require('lodash/isBoolean');

var _isBoolean3 = _interopRequireDefault(_isBoolean2);

var _isDate2 = require('lodash/isDate');

var _isDate3 = _interopRequireDefault(_isDate2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _isFinite2 = require('lodash/isFinite');

var _isFinite3 = _interopRequireDefault(_isFinite2);

var _isFunction2 = require('lodash/isFunction');

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _isNaN2 = require('lodash/isNaN');

var _isNaN3 = _interopRequireDefault(_isNaN2);

var _isNull2 = require('lodash/isNull');

var _isNull3 = _interopRequireDefault(_isNull2);

var _isNumber2 = require('lodash/isNumber');

var _isNumber3 = _interopRequireDefault(_isNumber2);

var _isObject2 = require('lodash/isObject');

var _isObject3 = _interopRequireDefault(_isObject2);

var _isPlainObject2 = require('lodash/isPlainObject');

var _isPlainObject3 = _interopRequireDefault(_isPlainObject2);

var _isRegExp2 = require('lodash/isRegExp');

var _isRegExp3 = _interopRequireDefault(_isRegExp2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _isTypedArray2 = require('lodash/isTypedArray');

var _isTypedArray3 = _interopRequireDefault(_isTypedArray2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Type validators

function isNotNull(value) {
  return !(0, _isNull3.default)(value) && !(0, _isUndefined3.default)(value);
}

function isNull(value) {
  return (0, _isNull3.default)(value) || (0, _isUndefined3.default)(value);
}

function isBoolean(value) {
  return (0, _isBoolean3.default)(value);
}

function isTrue(value) {
  return value === true;
}

function isFalse(value) {
  return value === false;
}

function isNumber(value) {
  return (0, _isNumber3.default)(value) && !(0, _isNaN3.default)(value) && (0, _isFinite3.default)(value);
}

function isNotANumber(value) {
  return (0, _isNaN3.default)(value);
}

function isInfinity(value) {
  return (0, _isNumber3.default)(value) && !(0, _isNaN3.default)(value) && !(0, _isFinite3.default)(value);
}

function isString(value) {
  return (0, _isString3.default)(value);
}

function isObject(value) {
  return (0, _isObject3.default)(value);
}

function isPlainObject(value) {
  return (0, _isPlainObject3.default)(value);
}

function isArray(value) {
  return (0, _isArray3.default)(value) || (0, _isTypedArray3.default)(value);
}

function isRegExp(value) {
  return (0, _isRegExp3.default)(value);
}

function isDate(value) {
  return (0, _isDate3.default)(value);
}

function isFunction(value) {
  return (0, _isFunction3.default)(value);
}

// String validators

function isEmail(value) {
  return (/^.+@.+$/.test(value)
  );
}

function isUppercase(value) {
  return (0, _isString3.default)(value) && value.toUpperCase() === value;
}

function isLowercase(value) {
  return (0, _isString3.default)(value) && value.toLowerCase() === value;
}

// Length validators

function isNotEmpty(value) {
  return !(0, _isEmpty3.default)(value);
}

function isEmpty(value) {
  return (0, _isEmpty3.default)(value);
}